local IDToCount = {
	[527] = 3,
	[528] = 3,
	[529] = 3,
	[530] = 3,
	[526] = 4,
	[610] = 3,
	[611] = 3,
	[612] = 3,
	[613] = 3,
	[716] = 4,
	[717] = 4,
	[724] = 3,
	[725] = 3,
	[726] = 4,
	[728] = 4,
	[729] = 3,
	[730] = 3,
	[849] = 3, -- Город за стеной
	[850] = 3, -- Волшебное святилище
	[851] = 1, -- Подъем Императора
	[847] = 3, -- Шлаковый цех
	[846] = 3, -- Черная Кузня
	[848] = 3, -- Железный цех
	[823] = 1, -- Тигель Чернорука
	[982] = 3, -- Адский пролом
	[983] = 3, -- Залы Крови
	[984] = 3, -- Оплот Тьмы
	[985] = 3, -- Терраса Разрушителя
	[986] = 1 -- Черные врата
}

function printf(text, ...) print(string.format(text, ...)) end

local function isRaidFinderDungeonDisplayable(id)
	local name, typeID, subtypeID, minLevel, maxLevel, _, _, _, expansionLevel = GetLFGDungeonInfo(id)
	local myLevel = UnitLevel("player")
	return myLevel >= minLevel and myLevel <= maxLevel and EXPANSION_LEVEL >= expansionLevel
end

function RaidFinderQueueFrameSelectionDropDown_Initialize(self)
	local info = UIDropDownMenu_CreateInfo()
	for i=1, GetNumRFDungeons() do
		local id, name = GetRFDungeonInfo(i)
		local isAvailable, isAvailableToPlayer, hideIfUnmet = IsLFGDungeonJoinable(id)
		if( not hideIfUnmet or isAvailable ) then
			if ( isAvailable or isAvailableToPlayer or isRaidFinderDungeonDisplayable(id) ) then
				if ( isAvailable ) then
					local _, BossKill = GetLFGDungeonNumEncounters(id)

					if ( BossKill == IDToCount[id] ) then
						name = string.format("|cffff0000%s [%d/%d]|r", name , BossKill, IDToCount[id])
					else
						name = string.format("%s [%d/%d]", name , BossKill, IDToCount[id])
					end
					info.text = name
					info.value = id
					info.isTitle = nil
					info.func = RaidFinderQueueFrameSelectionDropDownButton_OnClick
					info.disabled = nil
					info.checked = (RaidFinderQueueFrame.raid == info.value)
					info.tooltipWhileDisabled = nil
					info.tooltipOnButton = nil
					info.tooltipTitle = nil
					info.tooltipText = nil
					UIDropDownMenu_AddButton(info)
				else
					info.text = name
					info.value = id
					info.isTitle = nil
					info.func = nil
					info.disabled = 1
					info.checked = nil
					info.tooltipWhileDisabled = 1
					info.tooltipOnButton = 1
					info.tooltipTitle = YOU_MAY_NOT_QUEUE_FOR_THIS
					info.tooltipText = LFGConstructDeclinedMessage(id)
					UIDropDownMenu_AddButton(info)
				end
			end
		end
	end
end
